Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	
	Dim BASE As Integer
	
	Private Sub CtrMode(ByRef cntr As Byte, ByRef mode As Byte)
		Dim ctrl As Byte
		
		ctrl = (cntr * (2 ^ 6)) Or &H30s Or (mode * (2 ^ 1))
		OutPortB(BASE + 3, ctrl)
	End Sub
	
	'UPGRADE_NOTE: Val was upgraded to Val_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
	Private Sub LoadCtr(ByRef C As Integer, ByRef Val_Renamed As Integer)
		OutPortB(BASE + C, Val_Renamed And &HFFs)
		OutPortB(BASE + C, (CShort(Val_Renamed And &HFF00s) / 256) And &HFFs)
	End Sub
	
	Private Function POW(ByRef x As Double, ByRef y As Integer) As Double
		
		Dim count As Short
		Dim total As Double
		total = x
		
		For count = 2 To y
			total = total * x
		Next count
		
		POW = total
		
		
	End Function
	
	
	Private Sub beginBTN_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles beginBTN.Click
		Dim BUFFER(30000) As Integer
		Dim count As Integer
		
		
		If beginBTN.Text = "&Begin" Then
			
			beginBTN.Text = "STOP"
			BASE = CInt("&h" & addrEDIT.Text)
			
			'*****************************************************
			'** This for loop will fill the buffer with the following
			'** three wave forms and rescales them to have the same period:
			'** 1) sin(x^2) from x = -3.3 to 3.3
			'** 2) cos(x^2) from x = -3.0 to 3.0
			'** 3) sin(x^2) * cos (x^2) from x = -1.9 to 1.9
			'*****************************************************
			
			
			For count = 0 To 9999
				BUFFER(count * 3) = System.Math.Sin(POW(-3.3 + (0.00066 * count), 2)) * 2047# + 2048#
				BUFFER(count * 3) = BUFFER(count * 3) And &HFFFs
				
				BUFFER(count * 3 + 1) = System.Math.Cos(POW(-3# + (0.0006 * count), 2)) * 2047# + 2048#
				BUFFER(count * 3 + 1) = BUFFER(count * 3 + 1) And &HFFFs
				
				BUFFER(count * 3 + 2) = System.Math.Sin(POW(-1.9 + (0.00038 * count), 2)) * System.Math.Cos(POW(-1.9 + (0.00038 * count), 2)) * 2047# + 2048#
				BUFFER(count * 3 + 2) = BUFFER(count * 3 + 2) And &HFFFs
				BUFFER(count * 3 + 2) = BUFFER(count * 3 + 2) Or &H2000s
			Next count
			
			BUFFER(29999) = BUFFER(29999) Or &H1000s 'this is the end of the stream and the card needs to loop
			
			OutPortB(BASE + &H1As, 0) 'we will only be writing to the first 30k addresses
			'so we get to leave bit 16 of the SRAM addr at 0
			
			For count = 0 To 29999
				
				OutPort(BASE + &H18s, count * 2) 'set the address we are going to write to
				OutPort(BASE + &H1Cs, BUFFER(count)) 'write the value for that address
			Next count
			
			CtrMode(1, 2) 'set counter 1 to mode 2
			CtrMode(2, 2) 'set counter 2 to mode 2
			
			LoadCtr(1, 5) 'load counter 1 to 5 ticks
			LoadCtr(2, 10) 'load counter 2 to 10 ticks
			
			OutPortB(BASE + &H10s, &H41s) 'tell the card to start and enable the
			'ARB
			
		Else
			OutPortB(BASE + &H10s, 0) 'tell the card to stop
			beginBTN.Text = "&Begin"
		End If
		
	End Sub
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		addrEDIT.Text = "300"
		infoLBL.Text = "This program will output three wave forms from the 104-DA12-8." & vbCrLf
		infoLBL.Text = infoLBL.Text & "The wave forms will be output on DACS 0 - 2." & vbCrLf
		infoLBL.Text = infoLBL.Text & "The wave forms will stop when the user clicks stop or exits the program"
	End Sub
	
	Private Sub Form1_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		OutPortB(BASE + &H10s, 0) 'tell the card to stop
	End Sub
End Class